package browser;

import java.util.Enumeration;

import javax.jms.Queue;

import javax.naming.Context;
import javax.naming.InitialContext;

import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.Message;
import javax.jms.QueueSender;
import javax.jms.QueueSession;
import javax.jms.QueueBrowser;
import javax.jms.QueueReceiver;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;

public class Receiver
{
    public static void main(String[] args) throws Exception
    {
        // get the initial context
        InitialContext ctx = new InitialContext();

        // lookup the queue object
        Queue queue = (Queue) ctx.lookup("queue/queue0");

        // lookup the queue connection factory
        QueueConnectionFactory connFactory = (QueueConnectionFactory) ctx.
            lookup("queue/connectionFactory");

        // create a queue connection
        QueueConnection queueConn = connFactory.createQueueConnection();

        // create a queue session
        QueueSession queueSession = queueConn.createQueueSession(false,
            Session.DUPS_OK_ACKNOWLEDGE);

        // create a queue browser
        QueueBrowser queueBrowser = queueSession.createBrowser(queue);

        // start the connection
        queueConn.start();

        System.out.println("\nBrowse all messages first...");

        // Enumerate all the messages on the queue
        Enumeration enum = queueBrowser.getEnumeration();

        // Loop through enumeration
        while (enum.hasMoreElements()) {
            Message message = (Message) enum.nextElement();
            System.out.println("Browse message#: "+
                message.getStringProperty("MsgNumber"));
        }
        // close the browsing queue connection
        queueBrowser.close();

        System.out.println("\nNow read (process) all of the messages...");
        // create a queue receiver
        QueueReceiver queueReceiver = queueSession.createReceiver(queue);
        while (true) {
            Message message = queueReceiver.receiveNoWait();
            if (null == message) break;
            System.out.println("Received message#: "+
                message.getStringProperty("MsgNumber"));
        }
        // close the reading queue connection
        queueConn.close();
    }
}
