package destination;

import javax.jms.Queue;
import javax.jms.QueueConnectionFactory;

import javax.naming.Context;
import javax.naming.InitialContext;

import com.sssw.jms.api.JMQQueue;
import com.sssw.jms.api.JMQDestination;
import com.sssw.jms.api.JMQQueueConnection;

import com.sssw.jms.api.admin.JMQDestinationAdmin;

// Note: destination deletion requires private APIs

public class DestroyQueue
{
    public static void main(String[] args) throws Exception
    {
	// get the initial context
	InitialContext ctx = new InitialContext();

	// destroy a destination queue

	// create a JMS Queue Connection
	QueueConnectionFactory qconFactory = (QueueConnectionFactory) ctx.
	    lookup("queue/connectionFactory");
	JMQQueueConnection queueConn = (JMQQueueConnection) qconFactory.
	    createQueueConnection();

	// destroy the queue
	String queueName = (args.length > 0) ? args[0] : "myQueue";
	queueConn.getDestinationAdmin().deleteDestination(queueName, 
	    JMQDestination.QUEUE);
	System.out.println("Destroyed queue: " + queueName);

	// close the queue connection
	queueConn.close();
    }
}