package pubsub;

import javax.jms.Topic;

import javax.naming.Context;
import javax.naming.InitialContext;

import javax.jms.Topic;
import javax.jms.Session;
import javax.jms.Message;
import javax.jms.TopicSession;
import javax.jms.TopicSubscriber;
import javax.jms.TopicConnection;
import javax.jms.TopicConnectionFactory;

public class SimpleSubscriber
{
    public static void main(String[] args) throws Exception
    {
	// get the initial context
	InitialContext ctx = new InitialContext();

	// lookup the topic object
	Topic topic = (Topic) ctx.lookup("topic/topic0");

	// lookup the topic connection factory
	TopicConnectionFactory connFactory = (TopicConnectionFactory) ctx.
	    lookup("topic/connectionFactory");

	// create a topic connection
	TopicConnection topicConn = connFactory.createTopicConnection();

	// create a topic session
	TopicSession topicSession = topicConn.createTopicSession(false,
	    Session.DUPS_OK_ACKNOWLEDGE);

	// create a topic subscriber
	TopicSubscriber topicSubscriber = topicSession.createSubscriber(topic);

	// start the connection
	topicConn.start();

	// get the number of messages to receive
	int numMsgs = (args.length > 0) ? new Integer(args[0]).intValue() : 500;

	// receive the messages
	for (int i=0; i < numMsgs; i++) {
	    Message message = topicSubscriber.receive();
	    System.out.println("Received msg#"+(i+1));
	}

	// close the topic connection
	topicConn.close();
    }
}
