package selector;

import javax.jms.Queue;

import javax.naming.Context;
import javax.naming.InitialContext;

import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.Message;
import javax.jms.TextMessage;
import javax.jms.ObjectMessage;
import javax.jms.QueueSender;
import javax.jms.DeliveryMode;
import javax.jms.QueueSession;
import javax.jms.QueueReceiver;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;

import java.util.Hashtable;

public class Sender
{
    public static void main(String[] args) throws Exception
    {
        // get the initial context
        InitialContext ctx = new InitialContext();

        // lookup the queue object
        Queue queue = (Queue) ctx.lookup("queue/queue0");

        // lookup the queue connection factory
        QueueConnectionFactory connFactory = (QueueConnectionFactory) ctx.
            lookup("queue/connectionFactory");

        // create a queue connection
        QueueConnection queueConn = connFactory.createQueueConnection();

        // create a queue session
        QueueSession queueSession = queueConn.createQueueSession(false,
            Session.DUPS_OK_ACKNOWLEDGE);

        // create a queue sender
        QueueSender queueSender = queueSession.createSender(queue);
        queueSender.setDeliveryMode(DeliveryMode.PERSISTENT);

        // get the number of messages to send
        int numMsgs = (args.length > 0) ? new Integer(args[0]).intValue() : 20;

        // send the messages
        for (int i=0,j=0,k=0; i < numMsgs; i++) {
            j++;k++;	//Increment counters
            if (i == (numMsgs-1)) {
                Message message = queueSession.createMessage();
                message.setStringProperty("MarketStatus", "closed");
                System.out.println("Sending MarketStatus=closed message.");
                queueSender.send(message);
            }
            else if (k == 1) {
                TextMessage message = queueSession.createTextMessage();
                message.setText("News item #"+i);
                if (j == 3) message.setBooleanProperty("Interesting", true);
                System.out.println("Sending Text message. News item #"+i+((j==3)?"(Interesting)":""));
                queueSender.send(message);
            }
            else {
                ObjectMessage message = queueSession.createObjectMessage();
                Hashtable hTable = new Hashtable();
                hTable.put("symbol","sunw");
                hTable.put("bid",new String(""+(100+i)));	        		     
                hTable.put("ask",new String(""+(100+i+1)));	        		     
                message.setObject(hTable);
                if (j == 3) message.setBooleanProperty("Interesting", true);
                System.out.println("Sending Object message. "+hTable+((j==3)?"(Interesting)":""));
                queueSender.send(message);
                k=0; //reset counter
            }
            if (j == 3) j=0;
        }

        // close the queue connection
        queueConn.close();
    }
}
